Index: /trunk/src/world_entities/projectiles/hyperblast.cc
===================================================================
--- /trunk/src/world_entities/projectiles/hyperblast.cc	(revision 6810)
+++ /trunk/src/world_entities/projectiles/hyperblast.cc	(revision 6811)
@@ -40,5 +40,5 @@
 
   float modelSize = .3;
-  this->loadModel("models/projectiles/orx-hyperblast.obj", .3);
+  this->loadModel("models/projectiles/hyperblast.obj", 5);
 
   this->setMinEnergy(1);
@@ -58,8 +58,4 @@
 {
   /* this is normaly done by World.cc by deleting the ParticleEngine */
-  if (Hyperblast::extParticles != NULL && ClassList::getList(CL_HYPERBLAST)->size() <= 1)
-  {
-    Hyperblast::extParticles = NULL;
-  }
   if (Hyperblast::explosionParticles != NULL && ClassList::getList(CL_HYPERBLAST)->size() <= 1)
   {
@@ -69,24 +65,8 @@
 }
 
-SpriteParticles* Hyperblast::extParticles = NULL;
 SparkParticles* Hyperblast::explosionParticles = NULL;
 
 void Hyperblast::activate()
 {
-  if (unlikely(Hyperblast::extParticles == NULL))
-  {
-    Hyperblast::extParticles = new SpriteParticles(2000);
-    Hyperblast::extParticles->setName("HyperblastTrailParticles");
-    Hyperblast::extParticles->setMaterialTexture("maps/radial-trans-noise.png");
-    Hyperblast::extParticles->setLifeSpan(1.0, .3);
-    Hyperblast::extParticles->setRadius(0.0, .5);
-    Hyperblast::extParticles->setRadius(0.2, 2.0);
-    Hyperblast::extParticles->setRadius(.5, .8);
-    Hyperblast::extParticles->setRadius(1.0, .8);
-    Hyperblast::extParticles->setColor(0.0, 1,0,0,.7);
-    Hyperblast::extParticles->setColor(0.2, .8,.8,0,.5);
-    Hyperblast::extParticles->setColor(0.5, .8,.8,.8,.8);
-    Hyperblast::extParticles->setColor(1.0, .8,.8,.8,.0);
-  }
   if (unlikely(Hyperblast::explosionParticles == NULL))
   {
@@ -103,8 +83,8 @@
   }
 
-  this->emitter->setSystem(Hyperblast::extParticles);
+  this->emitter->setSystem(Hyperblast::explosionParticles);
 
   this->updateNode(0);
-  this->emitter->setEmissionRate(45.0);
+  this->emitter->setEmissionRate(245.0);
   this->emitter->setEmissionVelocity(0.0);
 }
@@ -125,7 +105,4 @@
 void Hyperblast::collidesWith(WorldEntity* entity, const Vector& location)
 {
-  if (this->hitEntity != entity)
-    this->destroy();
-  this->hitEntity = entity;
 }
 
@@ -136,8 +113,4 @@
 void Hyperblast::tick (float dt)
 {
-  //Vector v = *this->flightDirection * ( this->speed * time * 1000 + 0.1);
-  Vector v = this->velocity * (dt);
-  this->shiftCoor(v);
-
   if(this->tickLifeCycle(dt))
     this->deactivate();
@@ -150,10 +123,5 @@
 {
   PRINTF(5)("DESTROY Hyperblast\n");
-  this->lifeCycle = .95; //!< @todo calculate this usefully.
-  this->emitter->setSystem(Hyperblast::explosionParticles);
 
-  this->emitter->setEmissionRate(1000.0);
-  this->emitter->setEmissionVelocity(50.0);
-//  this->deactivate();
 
 }
Index: /trunk/src/world_entities/projectiles/hyperblast.h
===================================================================
--- /trunk/src/world_entities/projectiles/hyperblast.h	(revision 6810)
+++ /trunk/src/world_entities/projectiles/hyperblast.h	(revision 6811)
@@ -11,5 +11,4 @@
 class Vector;
 class Weapon;
-class SpriteParticles;
 class SparkParticles;
 class ParticleEmitter;
@@ -36,5 +35,4 @@
   private:
     static FastFactory*               fastFactory;
-    static SpriteParticles*           extParticles;
     static SparkParticles*            explosionParticles;
 
Index: /trunk/src/world_entities/space_ships/hover.cc
===================================================================
--- /trunk/src/world_entities/space_ships/hover.cc	(revision 6810)
+++ /trunk/src/world_entities/space_ships/hover.cc	(revision 6811)
@@ -76,5 +76,5 @@
   Weapon* wpLeft = new TestGun(1);
   wpLeft->setName("testGun Left");
-  Weapon* cannon = dynamic_cast<Weapon*>(Factory::fabricate(CL_CANNON));
+  Weapon* cannon = dynamic_cast<Weapon*>(Factory::fabricate(CL_HYPERBLASTER));
 
   cannon->setName("BFG");
Index: /trunk/src/world_entities/weapons/cannon.cc
===================================================================
--- /trunk/src/world_entities/weapons/cannon.cc	(revision 6810)
+++ /trunk/src/world_entities/weapons/cannon.cc	(revision 6811)
@@ -74,5 +74,5 @@
 //  this->model = (Model*)ResourceManager::getInstance()->load("models/guns/test_gun.obj", OBJ, RP_CAMPAIGN);
 
-  this->loadModel("models/guns/plasmadriver_#.obj", 2.0);
+  this->loadModel("models/guns/cannon.obj", 1.0);
 
   this->setStateDuration(WS_SHOOTING, 2.0);
Index: /trunk/src/world_entities/weapons/hyperblaster.cc
===================================================================
--- /trunk/src/world_entities/weapons/hyperblaster.cc	(revision 6810)
+++ /trunk/src/world_entities/weapons/hyperblaster.cc	(revision 6811)
@@ -66,6 +66,6 @@
   this->setStateDuration(WS_SHOOTING, 2.0);
   this->setStateDuration(WS_RELOADING, 5.0);
-  this->setStateDuration(WS_ACTIVATING, .1);
-  this->setStateDuration(WS_DEACTIVATING, .4);
+  this->setStateDuration(WS_ACTIVATING, .8);
+  this->setStateDuration(WS_DEACTIVATING, .8);
 
   this->setEnergyMax(10);
@@ -97,11 +97,9 @@
 //     animation1->addKeyFrame(Vector(0, 0, 0), Quaternion(), 0.0, ANIM_LINEAR, ANIM_NULL);
 
-  animation2->addKeyFrame(Vector(1.0, -1.0, 0.0), Quaternion(), 0.3, ANIM_LINEAR, ANIM_NULL);
-  animation2->addKeyFrame(Vector(1.0, 0.0, 0.0), Quaternion(), 0.3, ANIM_LINEAR, ANIM_NULL);
-  animation2->addKeyFrame(Vector(0.0, 0.0, 0.0), Quaternion(), 0.3, ANIM_LINEAR, ANIM_NULL);
+  animation2->addKeyFrame(Vector(0.0, -1.0, 0.0), Quaternion(), 0.3, ANIM_LINEAR, ANIM_NULL);
+  animation2->addKeyFrame(Vector(0.0, 0.0, 0.0), Quaternion(), 0.5, ANIM_LINEAR, ANIM_NULL);
 
-  animation3->addKeyFrame(Vector(0.0, 0.0, 0.0), Quaternion(), 0.3, ANIM_LINEAR, ANIM_NULL);
-  animation3->addKeyFrame(Vector(1.0, -1.0, 0.0), Quaternion(), 0.3, ANIM_LINEAR, ANIM_NULL);
-  animation2->addKeyFrame(Vector(1.0, -1.0, 0.0), Quaternion(), 0.3, ANIM_LINEAR, ANIM_NULL);
+  animation3->addKeyFrame(Vector(0.0, 0.0, 0.0), Quaternion(), 0.5, ANIM_LINEAR, ANIM_NULL);
+  animation3->addKeyFrame(Vector(0.0, -1.0, 0.0), Quaternion(), 0.3, ANIM_LINEAR, ANIM_NULL);
 }
 