Index: trunk/src/defs/class_id.h
===================================================================
--- trunk/src/defs/class_id.h	(revision 6815)
+++ trunk/src/defs/class_id.h	(revision 6818)
@@ -10,6 +10,6 @@
 
 ### File Specific:
-   main-programmer: Patrick Boenzli
-   co-programmer: Benjamin Grauer
+   main-programmer: Benjamin Grauer
+   co-programmer: Patrick Boenzli
 
    2005-06-10: (bensch) added new sturcture to support multiple inheritance
@@ -18,7 +18,7 @@
 /*!
  * @file class_id.h
- * @brief list of orxonox ClassID's
- *
- *  this File is used to identify an Object with its class and also with its sub/super-classes.
+ * @brief contains a list of orxonox ClassID's (identities to register classes and their SuperClasses)
+ *
+ *  this File is used to identify an Object with its Class and also with its sub/super-classes.
  *  this is also used by the ObjectManager/Factory to identify and load important classes
  *
@@ -66,5 +66,5 @@
   CL_NULL                       =    0x00000000,
 
-  // superclasses
+  /// SUPER-classes
   CL_MASK_SUPER_CLASS           =    0xff000000,
   CL_BASE_OBJECT                =    0x00000000,
@@ -84,47 +84,19 @@
   CL_WORLD_ENTITY               =    0x40000000,
 
-  CL_GAME_WORLD                 =    0x50000000,
-  CL_GAME_WORLD_DATA            =    0x60000000,
-
-  CL_GRAPHICS_EFFECT            =    0x70000000,
-
-
-  // subsuper-classes derivations taken : 1, 2, 3, 5, a, b, c.     << THIS IS A LIST OF ALL THE DCL_MASK_SUBSUPERCLASS_ID's taken
-
-  // subsuper-classes
+  CL_GRAPHICS_EFFECT            =    0x80000000,
+
+
+  /// subsuper-classes
+  // subsuper-classes derivations taken : 1, 2, 5, a, b, c.   << THIS IS A LIST OF ALL THE DCL_MASK_SUBSUPERCLASS_ID's taken
   CL_MASK_SUBSUPER_CLASS        =    0x00fff000,
   CL_MASK_SUBSUPER_CLASS_IDA    =    0x00f00000,
   CL_MASK_SUBSUPER_CLASS_IDB    =    0x000ff000,
-  // SUPER-PNodes
-  CL_FIELD                      =    0x00101000,
-  // SUPER-WorldEntities
-  CL_PLAYABLE                   =    0x00201000,
-  CL_PLAYER                     =    0x00202000,
-  CL_NPC                        =    0x00204000,
-  CL_IMAGE_ENTITY               =    0x00206000,
-  CL_PLANET                     =    0x00207000,
-  CL_PROJECTILE                 =    0x00208000,
-  CL_WEAPON                     =    0x00210000,
-  CL_POWER_UP                   =    0x00220000,
-  CL_EXTENDABLE                 =    0x00240000,
-  // SUPER-Modeling
-  CL_TEXTURE                    =    0x00c01000,
-  CL_TEXTURE_SEQUENCE           =    0x00004000,
-
-  CL_TEXT                       =    0x00c02000,
-
-  CL_MODEL                      =    0x00d01000,
-  CL_STATIC_MODEL               =    0x00002000,
-  CL_VERTEX_ARRAY_MODEL         =    0x00004000,
-
-
-  CL_BILLBOARD                  =    0x10000001,
-
-  // subsuper-classes derivations taken : 1, 2, 5, a, b, c.     << THIS IS A LIST OF ALL THE DCL_MASK_SUBSUPERCLASS_ID's taken
 
   // lowest level classes
+  // These are also referenced to as Leaf-classes
   CL_MASK_LOWLEVEL_CLASS        =    0x00000fff,
 
-  // singleton classes (range from 0x00000f00 to 0x00000fff)
+
+  /// SINGLETON classes (range from 0x00000f00 to 0x00000fff)
   CL_MASK_SINGLETON             =    0x00000f00,
   CL_ORXONOX                    =    0x00000f01,
@@ -158,5 +130,17 @@
 
 
-  // StoryEntities (range from 0x00000100 to 0x000001ff)
+  /// SUPER-Modeling
+  CL_TEXTURE                    =    0x00c01000,
+  CL_TEXTURE_SEQUENCE           =    0x00c04000,
+  CL_TEXT                       =    0x00c02000,
+
+  CL_MODEL                      =    0x00d01000,
+  CL_STATIC_MODEL               =    0x00d02000,
+  CL_VERTEX_ARRAY_MODEL         =    0x00d04000,
+
+  /// StoryEntities (range from 0x00000100 to 0x000001ff)
+  CL_GAME_WORLD                 =    0x00101000,
+  CL_GAME_WORLD_DATA            =    0x00102000,
+
   CL_CAMPAIGN                   =    0x00000101,
   CL_CAMPAIGN_DATA              =    0x00000102,
@@ -169,9 +153,24 @@
   CL_MOVIE_LOADER               =    0x00000109,
 
-
-  // WorldEntities (range from 0x00000200 to 0x000004ff)
-  CL_CAMERA                     =    0x00000201,
-  CL_CAMERA_TARGET              =    0x00000202,
-
+  /// SUPER-PNodes
+  CL_FIELD                      =    0x00101000,
+
+  /// PNodes
+  CL_CAMERA                     =    0x00000101,
+  CL_CAMERA_TARGET              =    0x00000102,
+
+
+  /// SUPER-WorldEntities
+  CL_PLAYER                     =    0x00202000,
+
+  CL_PLAYABLE                   =    0x00201000,
+  CL_NPC                        =    0x00204000,
+  CL_PROJECTILE                 =    0x00208000,
+  CL_WEAPON                     =    0x00210000,
+  CL_POWER_UP                   =    0x00220000,
+  CL_EXTENDABLE                 =    0x00240000,
+
+  /// WorldEntities (range from 0x00000200 to 0x000004ff)
+  // Environments
   CL_ENVIRONEMENT               =    0x00000203,
   CL_SATELLITE                  =    0x00000204,
@@ -180,6 +179,7 @@
   CL_TERRAIN                    =    0x00000207,
   CL_WATER                      =    0x00000208,
-
-  CL_TEST_ENTITY                =    0x00000209,
+  CL_PLANET                     =    0x00000209,
+
+  // Playables
   CL_SPACE_SHIP                 =    0x0000020a,
   CL_HELICOPTER                 =    0x0000020b,
@@ -188,4 +188,5 @@
   CL_HOVER                      =    0x0000020e,
 
+  // Powerups
   CL_TURRET_POWER_UP            =    0x00000211,
   CL_LASER_POWER_UP             =    0x00000212,
@@ -193,4 +194,5 @@
   CL_PARAM_POWER_UP             =    0x00000214,
 
+  // Weapons
   CL_TEST_GUN                   =    0x00000230,
   CL_TURRET                     =    0x00000231,
@@ -200,4 +202,5 @@
   CL_HYPERBLASTER               =    0x00000235,
 
+  // Projectiles
   CL_TEST_BULLET                =    0x00000240,
   CL_ROCKET                     =    0x00000241,
@@ -208,11 +211,20 @@
   CL_HYPERBLAST                 =    0x00000246,
 
+  // NPC's
   CL_NPC_TEST1                  =    0x00000301,
   CL_NPC_TEST2                  =    0x00000302,
-  CL_MOVIE_ENTITY               =    0x00000303,
-  CL_RECORDER                   =    0x00000304,
-
-
-  // gamePlay (range from 0x00000500 0x000005ff)
+
+  // Testing Entities
+  CL_TEST_ENTITY                =    0x00000209,
+
+  // misc
+  CL_MOVIE_ENTITY               =    0x00000310,
+  CL_RECORDER                   =    0x00000311,
+
+  CL_IMAGE_ENTITY               =    0x00000312,
+  CL_BILLBOARD                  =    0x00000313,
+
+
+  // GamePlay (range from 0x00000500 0x000005ff)
   CL_EVENT                      =    0x00000501,
   CL_KEY_MAPPER                 =    0x00000502,
@@ -223,5 +235,6 @@
   CL_HUD                        =    0x00000520,
 
-  // Physics stuff (range from 0x00000600 to 0x000007ff)
+
+  /// Physics stuff (range from 0x00000600 to 0x000007ff)
   CL_PHYSICS_CONNECTION         =    0x00000601,
   CL_FIELD_GRAVITY              =    0x00000610,
@@ -230,5 +243,5 @@
 
 
-  // Collision
+  /// Collision
   CL_COLLISION                  =    0x00000611,
   CL_BV_TREE                    =    0x00a01000,
@@ -240,5 +253,5 @@
   CL_BOUNDING_SPHERE            =    0x00040618,
 
-  // graphical stuff (range from 0x00000800 to 0x000009ff)
+  /// Graphical stuff (range from 0x00000800 to 0x000009ff)
   CL_FONT                       =    0x00000802,
 
@@ -268,5 +281,5 @@
   CL_LENSE_FLARE                =    0x70000002,
 
-  // GL-GUI
+  /// GL-GUI
   CL_GLGUI_WIDGET               =    0x00500000,
   CL_GLGUI_BUTTON               =    0x00501000,
@@ -281,5 +294,5 @@
   CL_GLGUI_BAR                  =    0x00000930,
 
-  // sound stuff (range from 0x00000a00 to 0x00000aff)
+  /// AUDIO stuff (range from 0x00000a00 to 0x00000aff)
   CL_SOUND_BUFFER               =    0x00000a01,
   CL_SOUND_SOURCE               =    0x00000a02,
@@ -287,5 +300,5 @@
 
 
-  // network stuff (range from 0x00000b00 to 0x00000bff)
+  /// NETWORK stuff (range from 0x00000b00 to 0x00000bff)
   CL_DATA_STREAM                =    0x00b01b00,
   CL_NETWORK_STREAM             =    0x00000b01,
@@ -299,5 +312,5 @@
 
 
-  // misc: (range from 0x00000d00 to 0x00000eff)
+  /// MISCELANEOUS: (range from 0x00000d00 to 0x00000eff)
   CL_ANIMATION                  =    0x00000d01,
   //  CL_ANIMATION3D                =    0x00000b02,
@@ -309,5 +322,4 @@
   CL_LOAD_PARAM                 =    0x00000d07,
   CL_CURVE                      =    0x00000d08,
-  CL_VECTOR                     =    0x00000d09,
   CL_CHARACTER_ATTRIBUTES       =    0x00000d0a,
   CL_TRACK_ELEMENT              =    0x00000d0b,