Index: /trunk/src/defs/class_id.h
===================================================================
--- /trunk/src/defs/class_id.h	(revision 6821)
+++ /trunk/src/defs/class_id.h	(revision 6822)
@@ -256,6 +256,6 @@
   CL_FONT                       =    0x00000802,
 
-  CL_PARTICLE_EMITTER           =    0x00201852,
-  CL_PARTICLE_SYSTEM            =    0x00202000,
+  CL_PARTICLE_EMITTER           =    0x00801000,
+  CL_PARTICLE_SYSTEM            =    0x00802000,
   CL_SPRITE_PARTICLES           =    0x00000853,
   CL_SPARK_PARTICLES            =    0x00000854,
@@ -263,5 +263,8 @@
   CL_DOT_PARTICLES              =    0x00000856,
   CL_MODEL_PARTICLES            =    0x00000857,
-//  CL_TEMPLATE_PARTICLES         =    0x00000857,
+  CL_DOT_EMITTER                =    0x00000861,
+  CL_BOX_EMITTER                =    0x00000862,
+  CL_SPHERE_EMITTER             =    0x00000863,
+  CL_MODEL_EMITTER              =    0x00000864,
 
   CL_MATERIAL                   =    0x00000804,
@@ -278,6 +281,6 @@
   CL_ENVIRONMENT                =    0x00000821,
   CL_SHADER                     =    0x00000822,
-  CL_FOG_EFFECT                 =    0x70000001,
-  CL_LENSE_FLARE                =    0x70000002,
+  CL_FOG_EFFECT                 =    0x00000841,
+  CL_LENSE_FLARE                =    0x00000842,
 
   /// GL-GUI
@@ -287,5 +290,5 @@
   CL_GLGUI_CHECKBUTTON          =    0x00000904,
   CL_GLGUI_RADIOBUTTON          =    0x00000905,
-  CL_GLGUI_CONTAINER            =    0x00002906,
+  CL_GLGUI_CONTAINER            =    0x00002000,
   CL_GLGUI_BOX                  =    0x00000907,
   CL_GLGUI_FRAME                =    0x00000908,
Index: /trunk/src/lib/network/shared_network_data.cc
===================================================================
--- /trunk/src/lib/network/shared_network_data.cc	(revision 6821)
+++ /trunk/src/lib/network/shared_network_data.cc	(revision 6822)
Index: /trunk/src/lib/particles/Makefile.am
===================================================================
--- /trunk/src/lib/particles/Makefile.am	(revision 6821)
+++ /trunk/src/lib/particles/Makefile.am	(revision 6822)
@@ -6,4 +6,5 @@
 libORXparticles_a_SOURCES = \
 			particle_emitter.cc \
+			dot_emitter.cc \
 			\
 			particle_system.cc \
@@ -18,4 +19,5 @@
 noinst_HEADERS = \
 			particle_emitter.h \
+			dot_emitter.h \
 			\
 			particle_system.h \
Index: /trunk/src/lib/particles/dot_emitter.cc
===================================================================
--- /trunk/src/lib/particles/dot_emitter.cc	(revision 6822)
+++ /trunk/src/lib/particles/dot_emitter.cc	(revision 6822)
@@ -0,0 +1,93 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific:
+   main-programmer: Benjamin Grauer
+   co-programmer: Patrick Boenzli
+*/
+
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_GRAPHICS
+
+#include "dot_emitter.h"
+
+#include "particle_system.h"
+
+#include "load_param.h"
+#include "factory.h"
+#include "debug.h"
+#include "stdlibincl.h"
+
+using namespace std;
+
+
+CREATE_FACTORY(DotEmitter, CL_DOT_EMITTER);
+
+/**
+ *  standard constructor
+*/
+DotEmitter::DotEmitter(const Vector& direction, float angle, float emissionRate,
+                       float velocity)
+  : ParticleEmitter(direction, angle, emissionRate, velocity)
+{
+  this->init();
+}
+
+/**
+ *  constructs and loads a DotEmitter from a XML-element
+ * @param root the XML-element to load from
+*/
+DotEmitter::DotEmitter(const TiXmlElement* root)
+  : ParticleEmitter()
+{
+  this->init();
+
+   if (root != NULL)
+     this->loadParams(root);
+}
+
+/**
+ *  standard destructor
+
+   removes the EmitterSystem from the ParticleEngine
+*/
+DotEmitter::~DotEmitter ()
+{
+  this->setSystem(NULL);
+}
+
+/**
+  @brief initializes default values of a ParitcleEmitter
+*/
+void DotEmitter::init()
+{
+  this->setClassID(CL_DOT_EMITTER, "DotEmitter");
+}
+
+void DotEmitter::emitParticles(unsigned int count) const
+{
+  Vector inheritVelocity = this->getVelocity() * this->inheritSpeed;
+
+  for (unsigned int i = 0; i < count; i++)
+  {
+    Vector randDir = Vector(rand()-RAND_MAX/2, rand()-RAND_MAX/2, rand()-RAND_MAX/2);
+    randDir.normalize();
+    randDir = (this->getAbsDir()*Quaternion(angle + randomAngle *((float)rand()/RAND_MAX -.5), randDir)).apply(this->direction);
+    Vector velocityV = randDir.getNormalized()*this->velocity + inheritVelocity;
+
+    // ROTATIONAL CALCULATION (this must not be done for all types of particles.)
+    randDir = Vector(rand()-RAND_MAX/2, rand()-RAND_MAX/2, rand()-RAND_MAX/2);
+    randDir.normalize();
+    Quaternion orient = Quaternion(M_PI, randDir);
+    Quaternion moment = Quaternion(this->momentum + this->momentumRandom, randDir);
+
+    this->getSystem()->addParticle(this->getAbsCoor(), velocityV, orient, moment);
+
+  }
+}
Index: /trunk/src/lib/particles/dot_emitter.h
===================================================================
--- /trunk/src/lib/particles/dot_emitter.h	(revision 6822)
+++ /trunk/src/lib/particles/dot_emitter.h	(revision 6822)
@@ -0,0 +1,38 @@
+/*!
+ * @file dot_emitter.h
+ *  Definition of a DotEmitter
+ */
+
+#ifndef _DOT_EMITTER_H
+#define _DOT_EMITTER_H
+
+#include "particle_emitter.h"
+
+// Default values
+#define DOT_EMITTER_DEFAULT_SIZE              1.0
+
+//! A class to handle an Emitter.
+class DotEmitter : public ParticleEmitter
+{
+  friend class ParticleSystem;
+public:
+  DotEmitter(const Vector& direction, float angle = .5,
+             float emissionRate = 1.0, float velocity = 1.0);
+  DotEmitter(const TiXmlElement* root);
+  virtual ~DotEmitter();
+
+
+  /* controlling the emitter: interface */
+  void tick(float dt);
+
+  virtual void emitParticles(unsigned int count) const;
+
+private:
+  void init();
+
+private:
+  Vector          emitterSize;       //!< The size of the emitter (not for EMITTER_DOT).
+
+};
+
+#endif /* _DOT_EMITTER_H */
Index: /trunk/src/lib/particles/particle_emitter.cc
===================================================================
--- /trunk/src/lib/particles/particle_emitter.cc	(revision 6821)
+++ /trunk/src/lib/particles/particle_emitter.cc	(revision 6822)
@@ -21,5 +21,4 @@
 
 #include "load_param.h"
-#include "factory.h"
 #include "debug.h"
 #include "stdlibincl.h"
@@ -27,7 +26,4 @@
 using namespace std;
 
-
-CREATE_FACTORY(ParticleEmitter, CL_PARTICLE_EMITTER);
-
 /**
  *  standard constructor
@@ -36,22 +32,16 @@
                   float velocity)
 {
-  this->init();
-
+  this->setClassID(CL_PARTICLE_EMITTER, "ParticleEmitter");
+
+  this->system = NULL;
+
+  this->setInheritSpeed(PARTICLE_EMITTER_DEFAULT_INHERIT_SPEED);
+  this->setEmissionMomentum(0);
   this->direction = direction;
   this->setSpread(angle);
   this->setEmissionRate(emissionRate);
   this->setEmissionVelocity(velocity);
-}
-
-/**
- *  constructs and loads a ParticleEmitter from a XML-element
- * @param root the XML-element to load from
-*/
-ParticleEmitter::ParticleEmitter(const TiXmlElement* root)
-{
-  this->init();
-
-   if (root != NULL)
-     this->loadParams(root);
+
+  this->saveTime = 0.0;
 }
 
@@ -64,25 +54,4 @@
 {
   this->setSystem(NULL);
-}
-
-/**
-  @brief initializes default values of a ParitcleEmitter
-*/
-void ParticleEmitter::init()
-{
-  this->setClassID(CL_PARTICLE_EMITTER, "ParticleEmitter");
-
-  this->type = PARTICLE_EMITTER_DEFAULT_TYPE;
-  this->emitterSize = PARTICLE_EMITTER_DEFAULT_SIZE;
-  this->setInheritSpeed(PARTICLE_EMITTER_DEFAULT_INHERIT_SPEED);
-  this->setEmissionRate(PARTICLE_EMITTER_DEFAULT_EMISSION_RATE);
-  this->setSize(PARTICLE_EMITTER_DEFAULT_SIZE);
-  this->setEmissionMomentum(0);
-  this->setEmissionVelocity(1.0);
-  this->setSpread(M_PI);
-
-  this->system = NULL;
-
-  this->saveTime = 0.0;
 }
 
@@ -94,10 +63,4 @@
 {
   PNode::loadParams(root);
-
-  LoadParam(root, "type", this, ParticleEmitter, setType)
-    .describe("What type of emitter is this [dot, plane, cube, sphere].");
-
-  LoadParam(root, "size", this, ParticleEmitter, setSize)
-    .describe("How big the emitter is (no effect on dot-emitters)");
 
   LoadParam(root, "rate", this, ParticleEmitter, setEmissionRate)
@@ -139,55 +102,4 @@
 void ParticleEmitter::stop() {}
 
-
-
-
-
-/**
- * @param type the new Type of this emitter
-*/
-void ParticleEmitter::setType(EMITTER_TYPE type)
-{
-  this->type = type;
-}
-
-/**
- *  sets the type of emitter
- * @param type the type as a const char*
-   dot: EMITTER_DOT, plane: EMITTER_PLANE, cube: EMITTER_CUBE, sphere, EMITTER_SPHERE;
-*/
-void ParticleEmitter::setType(const char* type)
-{
-  if (!strcmp(type, "plane"))
-    this->setType(EMITTER_PLANE);
-  else if (!strcmp(type, "cube"))
-    this->setType(EMITTER_CUBE);
-  else if (!strcmp(type, "sphere"))
-    this->setType(EMITTER_SPHERE);
-  else
-    this->setType(EMITTER_DOT);
-}
-
-const char* ParticleEmitter::getTypeC() const
-{
-  if (this->type == EMITTER_PLANE)
-    return "EMITTER_PLANE";
-  else if (this->type == EMITTER_CUBE)
-    return "EMITTER_CUBE";
-  else if (this->type == EMITTER_SPHERE)
-    return "EMITTER_SPHERE";
-  else
-    return "EMITTER_DOT";
-}
-
-/**
- *  sets a new size to the emitter
-*/
-void ParticleEmitter::setSize(float emitterSize)
-{
-  if (emitterSize > 0.0)
-    this->emitterSize = emitterSize;
-  else
-    emitterSize = 0.0;
-}
 
 /**
@@ -280,7 +192,9 @@
     PRINTF(5)("emitting %f particles, saving %f seconds for the next timestep\n", count, this->saveTime);
 
-    if (likely(count > 0))
+    if (likely(count > 0.0f))
     {
-      Vector inheritVelocity = this->getVelocity() * this->inheritSpeed;
+      this->emitParticles((unsigned int)count);
+
+/*      Vector inheritVelocity = this->getVelocity() * this->inheritSpeed;
       for (int i = 0; i < (int)count; i++)
       {
@@ -294,13 +208,13 @@
         Vector extension; // the Vector for different fields.
 
-        if (this->type & EMITTER_PLANE)
-        {
-          extension = Vector(this->emitterSize * ((float)rand()/RAND_MAX -.5), 0, this->emitterSize * ((float)rand()/RAND_MAX - .5));
-          extension = this->getAbsDir().apply(extension);
-        }
-        else if (this->type & EMITTER_CUBE)
-        {
-          extension = Vector((float)rand()/RAND_MAX -.5, (float)rand()/RAND_MAX -.5, (float)rand()/RAND_MAX -.5) * this->emitterSize;
-        }
+//         if (this->type & EMITTER_PLANE)
+//         {
+//           extension = Vector(this->emitterSize * ((float)rand()/RAND_MAX -.5), 0, this->emitterSize * ((float)rand()/RAND_MAX - .5));
+//           extension = this->getAbsDir().apply(extension);
+//         }
+//         else if (this->type & EMITTER_CUBE)
+//         {
+//           extension = Vector((float)rand()/RAND_MAX -.5, (float)rand()/RAND_MAX -.5, (float)rand()/RAND_MAX -.5) * this->emitterSize;
+//         }
 
 
@@ -312,5 +226,5 @@
 
         this->system->addParticle(this->getAbsCoor() + extension - equalSpread, velocityV, orient, moment);
-      }
+      } */
     }
   }
@@ -322,6 +236,5 @@
 void ParticleEmitter::debug() const
 {
-  PRINT(0)(" Emitter %s\n", this->getName());
+  PRINT(0)(" ParticleEmitter %s::%s\n", this->getClassName(), this->getName());
   PRINT(0)("  EmissionRate: %f, Speed: %f, SpreadAngle: %f\n", this->getEmissionRate(), this->getEmissionVelocity(), this->getSpread());
-  PRINT(0)("  Size %f, Type: %s\n", this->getSize(), this->getTypeC());
-}
+}
Index: /trunk/src/lib/particles/particle_emitter.h
===================================================================
--- /trunk/src/lib/particles/particle_emitter.h	(revision 6821)
+++ /trunk/src/lib/particles/particle_emitter.h	(revision 6822)
@@ -16,16 +16,6 @@
 #define PARTICLE_EMITTER_DEFAULT_SIZE              1.0
 #define PARTICLE_EMITTER_DEFAULT_EMISSION_RATE     50
-#define PARTICLE_EMITTER_DEFAULT_TYPE              EMITTER_DOT
 #define PARTICLE_EMITTER_DEFAULT_INHERIT_SPEED     0.0
 #define PARTICLE_EMITTER_DEFAULT_SPREAD            M_PI
-
-//! The form of the Emitter to emit from
-typedef enum EMITTER_TYPE
-{
-  EMITTER_DOT     = 1,
-  EMITTER_PLANE   = 2,
-  EMITTER_SPHERE  = 4,
-  EMITTER_CUBE    = 8
-};
 
 //! A class to handle an Emitter.
@@ -34,11 +24,9 @@
   friend class ParticleSystem;
 public:
-  ParticleEmitter(const Vector& direction, float angle = .5,
+  ParticleEmitter(const Vector& direction = Vector(1.0,0.0,0.0) , float angle = .5,
                   float emissionRate = 1.0, float velocity = 1.0);
-  ParticleEmitter(const TiXmlElement* root);
   virtual ~ParticleEmitter();
 
-  void init();
-  virtual void loadParams(const TiXmlElement* root);
+  virtual void loadParams(const TiXmlElement* root = NULL);
 
   /* controlling the emitter: interface */
@@ -51,7 +39,4 @@
 
   /* controlling the behavour: these can be used as Animation interfaces */
-  void setType(EMITTER_TYPE type);
-  void setType(const char* type);
-  void setSize(float emitterSize);
   void setEmissionRate(float emissionRate);
   void setInheritSpeed(float value);
@@ -60,13 +45,6 @@
   void setEmissionMomentum(float momentum, float randomMomentum = 0.0);
 
-  void setDirection(float x, float y, float z) { this->direction = Vector(x,y,z); }
-  ; //!< todo this should be done via PNODE
+  void setDirection(float x, float y, float z) { this->direction = Vector(x,y,z); }; //!< todo this should be done via PNODE
 
-  /** @returns the type of the emitter */
-  inline EMITTER_TYPE getType() const { return this->type; };
-  /** @returns the Type as a const char * */
-  const char* getTypeC() const;
-  /** @returns the Size of the emitter */
-  inline float getSize() const { return this->emitterSize; };
   /** @returns the emissionRate */
   inline float getEmissionRate() const { return this->emissionRate; };
@@ -80,17 +58,14 @@
   inline float getEmissionMomentum() const { return this->momentum; };
 
+  virtual void emitParticles(unsigned int count) const = 0;
+
   void debug() const;
 
+protected:
 
-private:
-  ParticleSystem* system;            //!< The ParticleSystem this Emitter Emits into.
-
-  EMITTER_TYPE    type;              //!< The type of emitter this is.
-  float           emitterSize;       //!< The size of the emitter (not for EMITTER_DOT).
   float           inheritSpeed;      //!< How much speed the particle inherits from the Emitters speed.
   Vector          direction;         //!< emition direction.
   float           angle;             //!< max angle from the direction of the emitter
   float           randomAngle;       //!< random emission angle (angle +- angleRandom is the emitted angle.
-  float           emissionRate;      //!< amount of particles per seconds emitted by emitter.
   float           velocity;          //!< the initial speed of a Particles.
   float           randomVelocity;    //!< the random variation from the initial Speed.
@@ -98,5 +73,8 @@
   float           momentumRandom;    //!< The random variation of the Momentum.
 
+private:
+  ParticleSystem* system;            //!< The ParticleSystem this Emitter Emits into.
   float           saveTime;          //!< The time that was missing by the last Tick (otherwise there would be no emission when framefate is too big).
+  float           emissionRate;      //!< amount of particles per seconds emitted by emitter.
 };
 
Index: /trunk/src/world_entities/projectiles/bomb.cc
===================================================================
--- /trunk/src/world_entities/projectiles/bomb.cc	(revision 6821)
+++ /trunk/src/world_entities/projectiles/bomb.cc	(revision 6822)
@@ -25,5 +25,5 @@
 #include "object_manager.h"
 
-#include "particle_emitter.h"
+#include "dot_emitter.h"
 #include "particle_system.h"
 
@@ -50,5 +50,5 @@
   this->lifeSpan = 15;
 
-  this->emitter = new ParticleEmitter(Vector(0,1,0), M_2_PI, 100, 5);
+  this->emitter = new DotEmitter(Vector(0,1,0), M_2_PI, 100, 5);
   this->emitter->setParent(this);
   this->emitter->setSpread(M_PI, M_PI);
Index: /trunk/src/world_entities/projectiles/guided_missile.cc
===================================================================
--- /trunk/src/world_entities/projectiles/guided_missile.cc	(revision 6821)
+++ /trunk/src/world_entities/projectiles/guided_missile.cc	(revision 6822)
@@ -23,5 +23,5 @@
 #include "class_list.h"
 
-#include "particle_emitter.h"
+#include "dot_emitter.h"
 #include "sprite_particles.h"
 
@@ -46,5 +46,5 @@
   this->maxVelocity = 75;
 
-  this->emitter = new ParticleEmitter(Vector(0,1,0), M_2_PI, 100, 5);
+  this->emitter = new DotEmitter(Vector(0,1,0), M_2_PI, 100, 5);
   this->emitter->setParent(this);
   this->emitter->setSpread(M_PI, M_PI);
Index: /trunk/src/world_entities/projectiles/hyperblast.cc
===================================================================
--- /trunk/src/world_entities/projectiles/hyperblast.cc	(revision 6821)
+++ /trunk/src/world_entities/projectiles/hyperblast.cc	(revision 6822)
@@ -23,5 +23,5 @@
 #include "class_list.h"
 
-#include "particle_emitter.h"
+#include "dot_emitter.h"
 #include "sprite_particles.h"
 #include "spark_particles.h"
@@ -47,7 +47,5 @@
   this->size = 4.0;
 
-  this->emitter = new ParticleEmitter(Vector(0,1,0), M_2_PI, 100, 5);
-  this->emitter->setType( EMITTER_CUBE );
-  this->emitter->setSize(10);
+  this->emitter = new DotEmitter(Vector(0,1,0), M_2_PI, 100, 5);
   this->emitter->setParent(this);
   this->emitter->setSpread(M_PI, M_PI);
Index: /trunk/src/world_entities/projectiles/laser.cc
===================================================================
--- /trunk/src/world_entities/projectiles/laser.cc	(revision 6821)
+++ /trunk/src/world_entities/projectiles/laser.cc	(revision 6822)
@@ -26,10 +26,8 @@
 #include "model.h"
 
-#include "particle_emitter.h"
+#include "dot_emitter.h"
 #include "sprite_particles.h"
-#include <cassert>
 
 #include <cassert>
-
 
 using namespace std;
@@ -50,5 +48,5 @@
   this->lifeSpan = 5.0;
 
-  this->emitter = new ParticleEmitter(Vector(0,1,0), M_2_PI, 100, 5);
+  this->emitter = new DotEmitter(Vector(0,1,0), M_2_PI, 100, 5);
   this->emitter->setParent(this);
   this->emitter->setSpread(M_PI, M_PI);
Index: /trunk/src/world_entities/projectiles/rocket.cc
===================================================================
--- /trunk/src/world_entities/projectiles/rocket.cc	(revision 6821)
+++ /trunk/src/world_entities/projectiles/rocket.cc	(revision 6822)
@@ -23,5 +23,5 @@
 #include "class_list.h"
 
-#include "particle_emitter.h"
+#include "dot_emitter.h"
 #include "sprite_particles.h"
 
@@ -45,5 +45,5 @@
   this->lifeSpan = 5;
 
-  this->emitter = new ParticleEmitter(Vector(0,1,0), M_2_PI, 100, 5);
+  this->emitter = new DotEmitter(Vector(0,1,0), M_2_PI, 100, 5);
   this->emitter->setParent(this);
   this->emitter->setSpread(M_PI, M_PI);
Index: /trunk/src/world_entities/projectiles/test_bullet.cc
===================================================================
--- /trunk/src/world_entities/projectiles/test_bullet.cc	(revision 6821)
+++ /trunk/src/world_entities/projectiles/test_bullet.cc	(revision 6822)
@@ -23,5 +23,5 @@
 #include "class_list.h"
 
-#include "particle_emitter.h"
+#include "dot_emitter.h"
 #include "sprite_particles.h"
 
@@ -45,5 +45,5 @@
   this->lifeSpan = 2;
 
-  this->emitter = new ParticleEmitter(Vector(0,1,0), M_2_PI, 100, 5);
+  this->emitter = new DotEmitter(Vector(0,1,0), M_2_PI, 100, 5);
   this->emitter->setParent(this);
   this->emitter->setSpread(M_PI, M_PI);
Index: /trunk/src/world_entities/space_ships/space_ship.cc
===================================================================
--- /trunk/src/world_entities/space_ships/space_ship.cc	(revision 6821)
+++ /trunk/src/world_entities/space_ships/space_ship.cc	(revision 6822)
@@ -28,5 +28,5 @@
 #include "weapons/cannon.h"
 
-#include "particle_emitter.h"
+#include "dot_emitter.h"
 #include "sprite_particles.h"
 
@@ -205,5 +205,5 @@
   dynamic_cast<Element2D*>(this->getWeaponManager()->getFixedTarget())->setVisibility( false);
 
-  this->burstEmitter = new ParticleEmitter(Vector(1,0,0), .01, 200, 0.0);
+  this->burstEmitter = new DotEmitter(Vector(1,0,0), .01, 200, 0.0);
   this->burstEmitter->setParent(this);
   this->burstEmitter->setRelCoor(-1, .5, 0);
@@ -531,9 +531,9 @@
 
   byte b;
-  
+
   while ( SYNCHELP_READ_REMAINING()>0 )
   {
     SYNCHELP_READ_BYTE( b, NWT_SS_B );
-    
+
     if ( b == DATA_state )
     {
@@ -544,5 +544,5 @@
       continue;
     }
-    
+
     if ( b == DATA_flags )
     {
@@ -559,8 +559,8 @@
       bRollL = (flags & MASK_bRollL) != 0;
       bRollR = (flags & MASK_bRollR) != 0;
-      
+
       continue;
     }
-    
+
     if ( b == DATA_mouse )
     {
@@ -569,16 +569,16 @@
       SYNCHELP_READ_FLOAT( mouseDir.v.y, NWT_SS_MOUSEDIRY );
       SYNCHELP_READ_FLOAT( mouseDir.v.z, NWT_SS_MOUSEDIRZ );
-      
+
       continue;
     }
-    
+
     if ( b == DATA_sync )
     {
       if ( this->getOwner() != this->getHostID() )
         SYNCHELP_READ_FKT( PNode::writeSync, NWT_SS_PN_SYNC );
-      
+
       continue;
     }
-    
+
     if ( b == DATA_velocity )
     {
@@ -588,5 +588,5 @@
     }
   }
-  
+
   return SYNCHELP_READ_N;
 }
@@ -621,5 +621,5 @@
 
   *reciever = 0;
-  
+
   if ( this->getOwner() == this->getHostID() && PNode::needsReadSync() )
   {