Index: trunk/src/defs/class_id.h
===================================================================
--- trunk/src/defs/class_id.h	(revision 6822)
+++ trunk/src/defs/class_id.h	(revision 6831)
@@ -98,44 +98,34 @@
 
 
-  /// SINGLETON classes (range from 0x00000f00 to 0x00000fff)
-  CL_MASK_SINGLETON             =    0x00000f00,
-  CL_ORXONOX                    =    0x00000f01,
-  CL_NULL_PARENT                =    0x00000f02,
-  CL_PILOT_PARENT               =    0x00000f03,
-  CL_OBJECT_MANAGER             =    0x00000f04,
-  CL_RESOURCE_MANAGER           =    0x00000f05,
-  CL_GARBAGE_COLLECTOR          =    0x00000f06,
-  CL_GAME_LOADER                =    0x00000f07,
-  CL_GRAPHICS_ENGINE            =    0x00000f08,
-  CL_TEXT_ENGINE                =    0x00000f09,
-  CL_LIGHT_MANAGER              =    0x00000f0a,
-  CL_EVENT_HANDLER              =    0x00000f0b,
-  CL_PHYSICS_ENGINE             =    0x00000f0c,
-  CL_CD_ENGINE                  =    0x00000f0d,
-  CL_PARTICLE_ENGINE            =    0x00000f0e,
-  CL_SOUND_ENGINE               =    0x00000f0f,
-  CL_ANIMATION_PLAYER           =    0x00000f10,
-  CL_TRACK_MANAGER              =    0x00000f11,
-  CL_TRACK_NODE                 =    0x00000f12,
-  CL_STATE                      =    0x00000f13,
-  CL_FRAMEWORK                  =    0x00000f14,
-  CL_RENDER_2D                  =    0x00000f21,
-  CL_NULL_ELEMENT_2D            =    0x00000f22,
-  CL_SHELL_BUFFER               =    0x00000f32,
-  CL_GLGUI_HANDLER              =    0x00000f40,
-  CL_GLGUI_MAIN_WIDGET          =    0x00000f41,
-  CL_NETWORK_MANAGER            =    0x00000f50,
-  CL_SHARED_NETWORK_DATA        =    0x00000f51,
-
-
-
-  /// SUPER-Modeling
-  CL_TEXTURE                    =    0x00c01000,
-  CL_TEXTURE_SEQUENCE           =    0x00c04000,
-  CL_TEXT                       =    0x00c02000,
-
-  CL_MODEL                      =    0x00d01000,
-  CL_STATIC_MODEL               =    0x00d02000,
-  CL_VERTEX_ARRAY_MODEL         =    0x00d04000,
+  /// SINGLETON classes (range from 0x00000000 to 0x000000ff)
+  CL_MASK_SINGLETON             =    0x00000000,
+  CL_ORXONOX                    =    0x00000001,
+  CL_NULL_PARENT                =    0x00000002,
+  CL_PILOT_PARENT               =    0x00000003,
+  CL_OBJECT_MANAGER             =    0x00000004,
+  CL_RESOURCE_MANAGER           =    0x00000005,
+  CL_GARBAGE_COLLECTOR          =    0x00000006,
+  CL_GAME_LOADER                =    0x00000007,
+  CL_GRAPHICS_ENGINE            =    0x00000008,
+  CL_TEXT_ENGINE                =    0x00000009,
+  CL_LIGHT_MANAGER              =    0x0000000a,
+  CL_EVENT_HANDLER              =    0x0000000b,
+  CL_PHYSICS_ENGINE             =    0x0000000c,
+  CL_CD_ENGINE                  =    0x0000000d,
+  CL_PARTICLE_ENGINE            =    0x0000000e,
+  CL_SOUND_ENGINE               =    0x0000000f,
+  CL_ANIMATION_PLAYER           =    0x00000010,
+  CL_TRACK_MANAGER              =    0x00000011,
+  CL_TRACK_NODE                 =    0x00000012,
+  CL_STATE                      =    0x00000013,
+  CL_FRAMEWORK                  =    0x00000014,
+  CL_RENDER_2D                  =    0x00000021,
+  CL_NULL_ELEMENT_2D            =    0x00000022,
+  CL_SHELL_BUFFER               =    0x00000032,
+  CL_GLGUI_HANDLER              =    0x00000040,
+  CL_GLGUI_MAIN_WIDGET          =    0x00000041,
+  CL_NETWORK_MANAGER            =    0x00000050,
+  CL_SHARED_NETWORK_DATA        =    0x00000051,
+
 
   /// StoryEntities (range from 0x00000100 to 0x000001ff)
@@ -154,191 +144,210 @@
 
   /// SUPER-PNodes
-  CL_FIELD                      =    0x00101000,
+  CL_FIELD                      =    0x00201000,
 
   /// PNodes
-  CL_CAMERA                     =    0x00000101,
-  CL_CAMERA_TARGET              =    0x00000102,
+  CL_CAMERA                     =    0x00000201,
+  CL_CAMERA_TARGET              =    0x00000202,
 
 
   /// SUPER-WorldEntities
-  CL_PLAYER                     =    0x00202000,
-
-  CL_PLAYABLE                   =    0x00201000,
-  CL_NPC                        =    0x00204000,
-  CL_PROJECTILE                 =    0x00208000,
-  CL_WEAPON                     =    0x00210000,
-  CL_POWER_UP                   =    0x00220000,
-  CL_EXTENDABLE                 =    0x00240000,
-
-  /// WorldEntities (range from 0x00000200 to 0x000004ff)
+  CL_PLAYER                     =    0x00302000,
+
+  CL_PLAYABLE                   =    0x00301000,
+  CL_NPC                        =    0x00304000,
+  CL_PROJECTILE                 =    0x00308000,
+  CL_WEAPON                     =    0x00310000,
+  CL_POWER_UP                   =    0x00320000,
+  CL_EXTENDABLE                 =    0x00340000,
+
+  /// WorldEntities (range from 0x00000300 to 0x000005ff)
   // Environments
-  CL_ENVIRONEMENT               =    0x00000203,
-  CL_SATELLITE                  =    0x00000204,
-  CL_SKYBOX                     =    0x00000205,
-  CL_SKYSPHERE                  =    0x00000206,
-  CL_TERRAIN                    =    0x00000207,
-  CL_WATER                      =    0x00000208,
-  CL_PLANET                     =    0x00000209,
+  CL_ENVIRONEMENT               =    0x00000303,
+  CL_SATELLITE                  =    0x00000304,
+  CL_SKYBOX                     =    0x00000305,
+  CL_SKYSPHERE                  =    0x00000306,
+  CL_TERRAIN                    =    0x00000307,
+  CL_WATER                      =    0x00000308,
+  CL_PLANET                     =    0x00000309,
 
   // Playables
-  CL_SPACE_SHIP                 =    0x0000020a,
-  CL_HELICOPTER                 =    0x0000020b,
-  CL_SPAWNING_POINT             =    0x0000020c,
-  CL_MD2_CREATURE               =    0x0000020d,
-  CL_HOVER                      =    0x0000020e,
+  CL_SPACE_SHIP                 =    0x0000030a,
+  CL_HELICOPTER                 =    0x0000030b,
+  CL_SPAWNING_POINT             =    0x0000030c,
+  CL_MD2_CREATURE               =    0x0000030d,
+  CL_HOVER                      =    0x0000030e,
 
   // Powerups
-  CL_TURRET_POWER_UP            =    0x00000211,
-  CL_LASER_POWER_UP             =    0x00000212,
-  CL_WEAPON_POWER_UP            =    0x00000213,
-  CL_PARAM_POWER_UP             =    0x00000214,
+  CL_TURRET_POWER_UP            =    0x00000311,
+  CL_LASER_POWER_UP             =    0x00000312,
+  CL_WEAPON_POWER_UP            =    0x00000313,
+  CL_PARAM_POWER_UP             =    0x00000314,
 
   // Weapons
-  CL_TEST_GUN                   =    0x00000230,
-  CL_TURRET                     =    0x00000231,
-  CL_AIMING_TURRET              =    0x00000232,
-  CL_CANNON                     =    0x00000233,
-  CL_TARGETING_TURRET           =    0x00000234,
-  CL_HYPERBLASTER               =    0x00000235,
+  CL_TEST_GUN                   =    0x00000330,
+  CL_TURRET                     =    0x00000331,
+  CL_AIMING_TURRET              =    0x00000332,
+  CL_CANNON                     =    0x00000333,
+  CL_TARGETING_TURRET           =    0x00000334,
+  CL_HYPERBLASTER               =    0x00000335,
 
   // Projectiles
-  CL_TEST_BULLET                =    0x00000240,
-  CL_ROCKET                     =    0x00000241,
-  CL_LASER                      =    0x00000242,
-  CL_BOMB                       =    0x00000243,
-  CL_GROUND_TURRET              =    0x00000244,
-  CL_GUIDED_MISSILE             =    0x00000245,
-  CL_HYPERBLAST                 =    0x00000246,
+  CL_TEST_BULLET                =    0x00000340,
+  CL_ROCKET                     =    0x00000341,
+  CL_LASER                      =    0x00000342,
+  CL_BOMB                       =    0x00000343,
+  CL_GROUND_TURRET              =    0x00000344,
+  CL_GUIDED_MISSILE             =    0x00000345,
+  CL_HYPERBLAST                 =    0x00000346,
 
   // NPC's
-  CL_NPC_TEST1                  =    0x00000301,
-  CL_NPC_TEST2                  =    0x00000302,
+  CL_NPC_TEST1                  =    0x00000401,
+  CL_NPC_TEST2                  =    0x00000402,
 
   // Testing Entities
-  CL_TEST_ENTITY                =    0x00000209,
+  CL_TEST_ENTITY                =    0x00000409,
 
   // misc
-  CL_MOVIE_ENTITY               =    0x00000310,
-  CL_RECORDER                   =    0x00000311,
-
-  CL_IMAGE_ENTITY               =    0x00000312,
-  CL_BILLBOARD                  =    0x00000313,
-
-
-  // GamePlay (range from 0x00000500 0x000005ff)
-  CL_EVENT                      =    0x00000501,
-  CL_KEY_MAPPER                 =    0x00000502,
-  CL_CROSSHAIR                  =    0x00000512,
-
-  CL_WEAPON_MANAGER             =    0x00000503,
-  CL_AMMO_CONTAINER             =    0x00000504,
-  CL_HUD                        =    0x00000520,
-
-
-  /// Physics stuff (range from 0x00000600 to 0x000007ff)
-  CL_PHYSICS_CONNECTION         =    0x00000601,
-  CL_FIELD_GRAVITY              =    0x00000610,
-  CL_FIELD_POINT_GRAVITY        =    0x00000611,
-  CL_FIELD_TWIRL                =    0x00000612,
+  CL_MOVIE_ENTITY               =    0x00000410,
+  CL_RECORDER                   =    0x00000411,
+
+  CL_IMAGE_ENTITY               =    0x00000412,
+  CL_BILLBOARD                  =    0x00000413,
+
+
+  /// GamePlay (range from 0x00000600 0x000006ff)
+  CL_EVENT                      =    0x00000601,
+  CL_KEY_MAPPER                 =    0x00000602,
+  CL_CROSSHAIR                  =    0x00000612,
+
+  CL_WEAPON_MANAGER             =    0x00000603,
+  CL_AMMO_CONTAINER             =    0x00000604,
+  CL_HUD                        =    0x00000620,
+
+
+  /// Physics stuff (range from 0x00000700 to 0x000008ff)
+  CL_PHYSICS_CONNECTION         =    0x00000701,
+  CL_FIELD_GRAVITY              =    0x00000710,
+  CL_FIELD_POINT_GRAVITY        =    0x00000711,
+  CL_FIELD_TWIRL                =    0x00000712,
 
 
   /// Collision
-  CL_COLLISION                  =    0x00000611,
-  CL_BV_TREE                    =    0x00a01000,
+  CL_COLLISION                  =    0x00000711,
+  CL_BV_TREE                    =    0x00701000,
   CL_BV_TREE_NODE               =    0x00002000,
-  CL_OBB_TREE                   =    0x00000614,
-  CL_OBB_TREE_NODE              =    0x00000615,
-  CL_BOUNDING_VOLUME            =    0x00a10000,
-  CL_OBB                        =    0x00020617,
-  CL_BOUNDING_SPHERE            =    0x00040618,
-
-  /// Graphical stuff (range from 0x00000800 to 0x000009ff)
+  CL_OBB_TREE                   =    0x00000714,
+  CL_OBB_TREE_NODE              =    0x00000715,
+  CL_BOUNDING_VOLUME            =    0x00710000,
+  CL_OBB                        =    0x00720000,
+  CL_BOUNDING_SPHERE            =    0x00740000,
+
+
+  /// Graphical stuff (range from 0x00000800 to 0x00000aff)
+  /// SUPER-Textures
+  CL_TEXTURE                    =    0x00801000,
+  CL_TEXTURE_SEQUENCE           =    0x00802000,
+  CL_TEXT                       =    0x00804000,
+
+  // Texutres.
   CL_FONT                       =    0x00000802,
-
-  CL_PARTICLE_EMITTER           =    0x00801000,
-  CL_PARTICLE_SYSTEM            =    0x00802000,
-  CL_SPRITE_PARTICLES           =    0x00000853,
-  CL_SPARK_PARTICLES            =    0x00000854,
-  CL_PNODE_PARTICLES            =    0x00000855,
-  CL_DOT_PARTICLES              =    0x00000856,
-  CL_MODEL_PARTICLES            =    0x00000857,
-  CL_DOT_EMITTER                =    0x00000861,
-  CL_BOX_EMITTER                =    0x00000862,
-  CL_SPHERE_EMITTER             =    0x00000863,
-  CL_MODEL_EMITTER              =    0x00000864,
-
-  CL_MATERIAL                   =    0x00000804,
-  CL_OBJ_MODEL                  =    0x00000807,
-
   CL_MOVIE_PLAYER               =    0x00000805,
   CL_MEDIA_CONTAINER            =    0x00000806,
-  CL_PROMITIVE_MODEL            =    0x00000808,
-  CL_MD2Model                   =    0x00000809,
-  CL_HEIGHT_MAP                 =    0x0000080a,
-  CL_GRID                       =    0x0000080b,
-
-  CL_LIGHT                      =    0x00000811,
-  CL_ENVIRONMENT                =    0x00000821,
-  CL_SHADER                     =    0x00000822,
+
+  /// Super-Models
+  CL_MODEL                      =    0x00901000,
+  CL_STATIC_MODEL               =    0x00902000,
+  CL_VERTEX_ARRAY_MODEL         =    0x00904000,
+
+  // Models
+  CL_OBJ_MODEL                  =    0x00000907,
+
+  CL_PRIMITIVE_MODEL            =    0x00000908,
+  CL_MD2Model                   =    0x00000909,
+  CL_HEIGHT_MAP                 =    0x0000090a,
+  CL_GRID                       =    0x0000090b,
+
+  // Particles
+  CL_PARTICLE_EMITTER           =    0x00a01000,
+  CL_PARTICLE_SYSTEM            =    0x00a02000,
+  CL_SPRITE_PARTICLES           =    0x00000a01,
+  CL_SPARK_PARTICLES            =    0x00000a02,
+  CL_PNODE_PARTICLES            =    0x00000a03,
+  CL_DOT_PARTICLES              =    0x00000a04,
+  CL_MODEL_PARTICLES            =    0x00000a05,
+  CL_DOT_EMITTER                =    0x00000a06,
+  CL_BOX_EMITTER                =    0x00000a07,
+  CL_SPHERE_EMITTER             =    0x00000a08,
+  CL_MODEL_EMITTER              =    0x00000a09,
+
+
+  CL_MATERIAL                   =    0x00000810,
+  CL_SHADER                     =    0x00000811,
+  CL_LIGHT                      =    0x00000821,
   CL_FOG_EFFECT                 =    0x00000841,
   CL_LENSE_FLARE                =    0x00000842,
 
+  // Element2D's  (range from 0x00000b00 to 0x00000bff)
   /// GL-GUI
-  CL_GLGUI_WIDGET               =    0x00500000,
-  CL_GLGUI_BUTTON               =    0x00501000,
-  CL_GLGUI_PUSHBUTTON           =    0x00000903,
-  CL_GLGUI_CHECKBUTTON          =    0x00000904,
-  CL_GLGUI_RADIOBUTTON          =    0x00000905,
-  CL_GLGUI_CONTAINER            =    0x00002000,
-  CL_GLGUI_BOX                  =    0x00000907,
-  CL_GLGUI_FRAME                =    0x00000908,
-  CL_GLGUI_WINDOW               =    0x00000909,
-  CL_GLMENU_IMAGE_SCREEN        =    0x00000920,
-  CL_GLGUI_BAR                  =    0x00000930,
-
-  /// AUDIO stuff (range from 0x00000a00 to 0x00000aff)
-  CL_SOUND_BUFFER               =    0x00000a01,
-  CL_SOUND_SOURCE               =    0x00000a02,
-  CL_SOUND_OGG_PLAYER           =    0x00000a11,
-
-
-  /// NETWORK stuff (range from 0x00000b00 to 0x00000bff)
-  CL_DATA_STREAM                =    0x00b01b00,
-  CL_NETWORK_STREAM             =    0x00000b01,
-  CL_NETWORK_PROTOCOL           =    0x00000b02,
-  CL_NETWORK_SOCKET             =    0x00000b03,
-  CL_SERVER_SOCKET              =    0X00000b04,
-  CL_CONNECTION_MONITOR         =    0x00000b05,
-  CL_HANDSHAKE                  =    0x00000b06,
-  CL_NETWORK_GAME_MANAGER       =    0x00000b07,
-
-
-
-  /// MISCELANEOUS: (range from 0x00000d00 to 0x00000eff)
-  CL_ANIMATION                  =    0x00000d01,
+  CL_GLGUI_WIDGET               =    0x00b00000,
+  CL_GLGUI_BUTTON               =    0x00b01000,
+  CL_GLGUI_PUSHBUTTON           =    0x00000b03,
+  CL_GLGUI_CHECKBUTTON          =    0x00000b04,
+  CL_GLGUI_RADIOBUTTON          =    0x00000b05,
+  CL_GLGUI_CONTAINER            =    0x00b02000,
+  CL_GLGUI_BOX                  =    0x00000b07,
+  CL_GLGUI_FRAME                =    0x00000b08,
+  CL_GLGUI_WINDOW               =    0x00000b09,
+  CL_GLMENU_IMAGE_SCREEN        =    0x00000b20,
+  CL_GLGUI_BAR                  =    0x00000b30,
+
+  /// AUDIO stuff (range from 0x00000c00 to 0x00000cff)
+  CL_SOUND_BUFFER               =    0x00000c01,
+  CL_SOUND_SOURCE               =    0x00000c02,
+  CL_SOUND_OGG_PLAYER           =    0x00000c11,
+
+
+  /// NETWORK stuff (range from 0x00000d00 to 0x00000dff)
+  CL_DATA_STREAM                =    0x00d01000,
+  CL_NETWORK_STREAM             =    0x00000d01,
+  CL_NETWORK_PROTOCOL           =    0x00000d02,
+  CL_NETWORK_SOCKET             =    0x00000d03,
+  CL_SERVER_SOCKET              =    0X00000d04,
+  CL_CONNECTION_MONITOR         =    0x00000d05,
+  CL_HANDSHAKE                  =    0x00000d06,
+  CL_NETWORK_GAME_MANAGER       =    0x00000d07,
+
+
+
+  /// MISCELANEOUS: (range from 0x00000e00 to 0x00000fff)
+  CL_ANIMATION                  =    0x00000e01,
   //  CL_ANIMATION3D                =    0x00000b02,
-  CL_QUICK_ANIMATION            =    0x00000d02,
-  CL_FACTORY                    =    0x00000d03,
-  CL_INI_PARSER                 =    0x00000d04,
-  CL_LIST                       =    0x00000d05,
-  CL_SUBSTRING                  =    0x00000d06,
-  CL_LOAD_PARAM                 =    0x00000d07,
-  CL_CURVE                      =    0x00000d08,
-  CL_CHARACTER_ATTRIBUTES       =    0x00000d0a,
-  CL_TRACK_ELEMENT              =    0x00000d0b,
-  CL_NUMBER                     =    0x00000d0c,
-  CL_EXECUTOR                   =    0x00000d0d,
-  CL_FAST_FACTORY               =    0x00000d01,
-  CL_SHELL                      =    0x00000d10,
-  CL_SHELL_COMMAND              =    0x00000d11,
-  CL_SHELL_COMMAND_CLASS        =    0x00000d12,
-  CL_SHELL_INPUT                =    0x00000d13,
-  CL_SHELL_COMPLETION           =    0x00000d14,
-  CL_SHELL_COMMAND_ALIAS        =    0x00000d15,
+  CL_QUICK_ANIMATION            =    0x00000e02,
+
+  CL_FACTORY                    =    0x00000e03,
+  CL_FAST_FACTORY               =    0x00000e01,
+  CL_LOAD_PARAM                 =    0x00000e07,
+
+  CL_INI_PARSER                 =    0x00000e04,
+
+  CL_TRACK_ELEMENT              =    0x00000e0b,
+  CL_LIST                       =    0x00000e05,
+  CL_SUBSTRING                  =    0x00000e06,
+  CL_CURVE                      =    0x00000e08,
+  CL_CHARACTER_ATTRIBUTES       =    0x00000e0a,
+  CL_NUMBER                     =    0x00000e0c,
+  CL_EXECUTOR                   =    0x00000e0d,
+
+  CL_SHELL                      =    0x00000e10,
+  CL_SHELL_COMMAND              =    0x00000e11,
+  CL_SHELL_COMMAND_CLASS        =    0x00000e12,
+  CL_SHELL_INPUT                =    0x00000e13,
+  CL_SHELL_COMPLETION           =    0x00000e14,
+  CL_SHELL_COMMAND_ALIAS        =    0x00000e15,
 
   // Spatial Data Separation
-  CL_SPATIAL_SEPARATION         =    0x00000d0d,
-  CL_QUADTREE                   =    0x00000d0e,
-  CL_QUADTREE_NODE              =    0x00000d0f,
+  CL_SPATIAL_SEPARATION         =    0x00000e0d,
+  CL_QUADTREE                   =    0x00000e0e,
+  CL_QUADTREE_NODE              =    0x00000e0f,
 };
 